/*____________________________________________________________________________
	Copyright (C) 1997 Network Associates, Inc. and its affiliates.
	All rights reserved.
	
	

	$Id: CSecureMemory.h,v 1.8.8.1 1998/11/12 03:09:44 heller Exp $
____________________________________________________________________________*/
#ifndef Included_CSecureMemory_h	/* [ */
#define Included_CSecureMemory_h


#include "pgpMem.h"
#include "pgpMem.h"
#include "pgpUtilities.h"

#include "MacSecureMemory.h"

/*____________________________________________________________________________
	Allocates a buffer of the specified size which is held in memory.
____________________________________________________________________________*/
class CSecureMemory
{
public:
	void *		mMemory;
	PGPSize		mSize;
	
	CSecureMemory( PGPMemoryMgrRef memMgr, PGPSize size )
	{
		mSize	= size;
		mMemory	= PGPNewSecureData( memMgr, size, 0 );
		pgpAssert( IsntNull( mMemory ) );
	}
	
	~CSecureMemory( void )
	{
		if ( IsntNull( mMemory ) )
		{
			PGPFreeData( mMemory );
			mMemory	= NULL;
		}
	}
};


#endif /* ] Included_CSecureMemory_h */


/*__Editor_settings____

	Local Variables:
	tab-width: 4
	End:
	vi: ts=4 sw=4
	vim: si
_____________________*/
